(*
Unit zum Messen von Kapazitten ber die Parallelschnittstelle.

Autor: Dieter Stotz
Programmsprache: TurboPascal 6.0
*)

UNIT CMess;

INTERFACE

uses crt,dos;

var
  perf                       : real;
  err                        : integer;
  env1                       : string;

function GetCap (var errflag:integer): real;

IMPLEMENTATION

function GetCap;

var
  LSWord,MSWord                   : word;
  cap                             : longint;
  capreal                         : real;
  errf                            : integer;

begin

  MSWord:=0;
  errf:=0;

  asm                                            (* Initialisierung *)
    CLI
    MOV  BX,0
    MOV  CX,0

@Discharge:                          (* Kapazitt zunchst entladen *)

    DEC  CX
    MOV  DX,$37A  {Kontrollport-Adresse initialisieren}

    MOV  AL,1  {L-Pegel auf \STROBE (Pin 1)}
    OUT  DX,AL
    JCXZ @Discharge

    AND  AL,$FE  {H-Pegel auf \STROBE (Pin 1)}
    OUT  DX,AL

    MOV  DX,$379  {Inputport-Adresse initialisieren}
    MOV  CX,0  {Zeitzhler auf Null setzen}

@Measure:                                                (* Messung *)
    IN   AL,DX  {Abfrage des Inputport}
    INC  CX  {Zeitzhler inkrementieren}
    JZ   @Carry  {Sprung bei berlauf nach @Carry}
    AND  AL,8  {Ist Pin 15 auf H-Potential}
    JZ   @Measure  {Falls nein, Messung weiterlaufen lassen}

    DEC  CX  {Zeitzhler dekrementieren (Korrektur)}
    MOV  [LSWord],CX  {CX ist niederwertiges Wort}

    MOV  DX,$37A  {Kontrollport-Adresse initialisieren}
    MOV  AL,1  {L-Pegel auf \STROBE (Pin 1)}
    OUT  DX,AL

    JMP  @End  {Sprung nach End}

@Carry:                             (* Hherwertiges Wort ermitteln *)
    INC  BX  {BX inkrementieren}
    CMP  BH,$7F
    JG   @Error  {Fehlerbehandlung bei Negativwert}
    JMP  @Measure  {Messung weiterlaufen lassen}

@Error:
    MOV  [errf],1  {Errorflag setzen}

                                              (* Kapazitt entladen *)
    MOV  DX,$37A  {Kontrollport-Adresse initialisieren}
    MOV  AL,1  {L-Pegel auf \STROBE (Pin 1)}
    OUT  DX,AL

@End:
    MOV  [MSWord],BX  {BX ist hherwertiges Wort}
  end;

  errflag:=errf;
  cap:=MSWord;
  cap:=cap shl 16;
  cap:=cap + LSWord;
  capreal:=cap*perf;
  GetCap:=capreal;

end;

begin
  env1:=getenv('perf');
  val(env1,perf,err);
  if (err<>0) or (env1='') then perf:=20;
end.